Codeforces 437E The Child and Polygon(区间DP)

题目链接:Codeforces 437E The Child and Polygon

题目大意:给出一个多边形,问说有多少种分割方法,将多边形分割为多个三角形。

解题思路:首先要理解向量叉积的性质,一开始将给出的点转换成顺时针,然后用区间dp计算。dp[i][j]表示从点i到点j可以有dp[i][j]种切割方法。然后点i和点j是否可以做为切割线,要经过判断,即在i和j中选择的话点k的话,点k要在i,j的逆时针方。

#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;
typedef long long ll;

const int N = 205;
const ll MOD = 1e9+7;

struct point {
    ll x, y;
    ll operator * (const point& c) const {
        return x * c.y - y * c.x;
    }
    point operator - (const point& c) const {
        point u;
        u.x = x - c.x;
        u.y = y - c.y;
        return u;
    }
}p[N];
int n;
ll dp[N][N];

void init () {
    scanf("%d", &n);
    memset(dp, -1, sizeof(dp));

    for (int i = 0; i < n; i++)
        scanf("%lld %lld", &p[i].x, &p[i].y);

    ll tmp = 0;
    p[n] = p[0];
    for (int i = 0; i < n; i++)
        tmp += p[i] * p[i+1];

    if (tmp < 0)
        reverse(p, p + n);
}

ll solve (int l, int r) {
    if (dp[l][r] != -1)
        return dp[l][r];

    ll& ans = dp[l][r];
    ans = 0;

    if (r - l == 1)
        return ans = 1;

    for (int i = l + 1; i < r; i++) {
        if ((p[l] - p[r]) * (p[i] - p[r]) > 0)
            ans = (ans + solve(l, i) * solve(i, r)) % MOD;
    }
    return ans;
}

int main () {
    init();
    printf("%lld\n", solve(0, n-1));
    return 0;
}

Codeforces 437E The Child and Polygon(区间DP)

时间: 2024-08-08 09:30:44

Codeforces 437E The Child and Polygon(区间DP)的相关文章

POJ 1179 Polygon 区间DP

链接:http://poj.org/problem?id=1179 题意:给出一个多边形,多边形的每个顶点是一个数字,每条边是一个运算符号"+"或者"x".要求的过程如下,手下移除一条边,即这条边不做运算.之后每次移除一条边,将其两边的数字进行对应边的运算,用得到的数字来替代原来的两个点.要求所有边都移除以后得到的最大的答案. 思路:典型的区间DP,在过程中每次操作的处理方式为dp_max[i][j]=dp[i][k]*dp[k+1][j],dp_max[i][j]

Codeforces 758D Ability To Convert(区间DP)

题目链接:http://codeforces.com/problemset/problem/758/D 题意:一个n进制下的数k,其中k不会用字母,如果有A就用10代替了.求k这个数对应的,在10进制下最小的数. 分析: 本质上是把数字分成若干段使得每一段 <n 且没有前导 0 dp[i] 表示前 i 个字符划分好之后能得到的最小数. 状态枚举下一段怎么切. 1 #include<cstdio> 2 #include<cstring> 3 #include<cstdli

Codeforces 509F Progress Monitoring (区间dp 或 记忆化搜索)

F. Progress Monitoring time limit per test 1 second memory limit per test 256 megabytes Programming teacher Dmitry Olegovich is going to propose the following task for one of his tests for students: You are given a tree T with n vertices, specified b

codeforces 149D - Coloring Brackets (区间dp)

题目大意: 给出一组合法的括号. 括号要么不涂颜色,要么就涂上红色或者绿色. 匹配的括号只能有一个有颜色. 两个相邻的括号不能有相同的颜色. 思路分析: 因为是一个合法的括号序列. 所以每个括号与之匹配的位置是一定的. 那么就可以将这个序列分成两个区间. (L - match[L] )  (match[L]+1, R) 用递归先处理小区间,再转移大区间. 因为条件的限制,所以记录区间的同时,还要记录区间端点的颜色. 然后就是一个递归的过程. #include <cstdio> #include

Codeforces Round #538 (Div. 2) D. Flood Fill 【区间dp || LPS (最长回文序列)】

任意门:http://codeforces.com/contest/1114/problem/D D. Flood Fill time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output You are given a line of nn colored squares in a row, numbered from 11 to nn f

Codeforces Round #106 (Div. 2) Coloring Brackets(区间DP)

题意:给你一组括号序列,让你进行染色,对于每个括号,有无色,红色,蓝色三种方案.染色需要满足这样的条件:互相匹配的括号,有且只有一个有颜色,相邻的括号不能颜色相同(可以同为无色),问合法的染色方案数(答案%1e9+7) 分析:根据题意能够看出是区间DP,并且状态转移的时候,依赖于左右两端的颜色,所以我们用dp[i][j][x][y]表示i到j的区间内左端颜色为x,右端颜色为y的方案数. 区间[i,j]可以由两种情况得到,一种是str[i],str[j]匹配,产生新的相匹配的括号,考虑在只有一端染

Timetable CodeForces - 946D (区间dp)

大意: n天, 每天m小时, 给定课程表, 每天的上课时间为第一个1到最后一个1, 一共可以逃k次课, 求最少上课时间. 每天显然是独立的, 对每天区间dp出逃$x$次课的最大减少时间, 再对$n$天dp即可. #include <iostream> #include <sstream> #include <algorithm> #include <cstdio> #include <math.h> #include <set> #i

codeforces 607B- Zuma(区间DP)

传送门:QAQQAQ 题意:给你一个数组,每次可以删一个连续的回文串(包括长度为1),问最少删几次 思路:挺简单的DP题,但要想清楚有难度(先看数据范围,n^3可以过) 区间DP,dp[i][j]可以有两种情况更新而来: 1.a[i]==a[j],把最外面一层挖掉,答案为dp[i+1][j-1] 2.对于所有dp[i][j],枚举中间点,把它切成两半,分别求回文串加起来 为减少更新时溢出等不必要的麻烦,我把len=1或2都特判掉了 代码: #include<bits/stdc++.h> usi

CodeForces - 1114D Flood Fill (区间dp)

You are given a line of nn colored squares in a row, numbered from 11 to nn from left to right. The ii-th square initially has the color cici. Let's say, that two squares ii and jj belong to the same connected component if ci=cjci=cj, and ci=ckci=ck